! *****************************************************************************
! *   move wave as CIP method                                                 *
! *****************************************************************************

      subroutine advec_1D( f, g, vel, fnew, gnew )
   
      use m_param
      
      implicit none
      real(8):: f(-1:mx1), g(-1:mx1)
      real(8):: vel(-1:mx1)
      real(8):: fnew(-1:mx1), gnew(-1:mx1)
      real(8):: fi, fiup, gi, giup, fn1, gn1
      real(8):: XX, DD, gzi
      integer:: i      
      integer:: ixsgn, iup
      
!  ****  calculate advection using CIP method  ****

!      write ( 6,* ) 'advec_1D f,g'
!      do i = 0,mx
!        write ( 6,* ) i,f(i),g(i)
!      end do
      
      do i = 0,mx

        ixsgn=1
        XX = vel(i)
        if ( XX < 0.0d0 ) ixsgn = -1
        iup = i - ixsgn
        
        DD  = -dble( ixsgn ) * dx
        
        fi   = f(i)
        fiup = f(iup)
        gi   = g(i)
        giup = g(iup)
        
        gzi = -vel(i) * dt
      
        call CIP_1d( fi, fiup, gi, giup, DD, gzi, fn1, gn1 )
        
!        write ( 6,* ) i,fn1,gn1
        
        fnew(i) = fn1
        gnew(i) = gn1 - dt * gn1 * 0.5d0 * ( vel(i+1) - vel(i-1) ) / dx 
!        write ( 6,* ) i,fnew(i),gnew(i)

      end do

!      write ( 6,* ) 'advec_1D fnew,gnew'
!      do i = 0,mx
!        write ( 6,* ) i,fnew(i),gnew(i)
!      end do

      return

   end subroutine advec_1D