! *****************************************************************************
! *   calculate c, v, w from u, h                                             *
! *****************************************************************************

   subroutine pq_to_cuhvw( p, q, c, u, h, v, w )
   
      use m_param
      
      implicit none
      real(8):: p(-1:mx1),  q(-1:mx1)
      real(8):: u(-1:mx1),  h(-1:mx1) 
      real(8):: c(-1:mx1),  v(-1:mx1),  w(-1:mx1) 
      
      c(:) = 0.5d0 * ( p(:) + q(:) )
      u(:) = p(:) - q(:)
      h(:) = c(:)**2 / ga
      v(:) = u(:) + c(:) 
      w(:) = u(:) - c(:) 
      
      return

   end subroutine pq_to_cuhvw