! *****************************************************************************
! *   move wave as CIP method                                                 *
! *****************************************************************************

      subroutine set_bound( f, g, vel, fnew, gnew )
   
      use m_param
      
      implicit none
      real(8):: f(-1:mx1), g(-1:mx1)
      real(8):: vel(-1:mx1)
      real(8):: fnew(-1:mx1), gnew(-1:mx1)
      real(8):: fi, fiup, gi, giup, fn1, gn1
      real(8):: XX, DD, gzi
      integer:: i      
      integer:: ixsgn, iup
      
!   ****  Left boundary  ****

      i = -1
!      write (6,* ) vel(i)
      if ( vel(i) < 0.0d0 ) then

        ixsgn=-1
        iup = 0
        
        DD  = -dble( ixsgn ) * dx
        
        fi   = f(i)
        fiup = f(iup)
        gi   = g(i)
        giup = g(iup)
        
        gzi = -vel(i) * dt
      
        call CIP_1d( fi, fiup, gi, giup, DD, gzi, fn1, gn1 )
              
        fnew(i) = fn1
        gnew(i) = gn1 - dt * gn1 * ( vel(i+1) - vel(i) ) / dx
!        write (6,*) 'Bound-L_out',i,fnew(i),gnew(i)
        
       else
       
        fnew(i) = f(i)
        gnew(i) = g(i)
!        write (6,*) 'Bound-L_in ',i,fnew(i),gnew(i)

      end if

!   ****  Right boundary  ****

      i = mx1
!      write (6,* ) vel(i)
      if ( vel(i) > 0.0d0 ) then

        ixsgn=1
        iup = mx
        
        DD  = -dble( ixsgn ) * dx
        
        fi   = f(i)
        fiup = f(iup)
        gi   = g(i)
        giup = g(iup)
        
        gzi = -vel(i) * dt
      
        call CIP_1d( fi, fiup, gi, giup, DD, gzi, fn1, gn1 )
              
        fnew(i) = fn1
        gnew(i) = gn1 - dt * gn1 * ( vel(i) - vel(i-1) ) / dx
!        write (6,*) 'Bound-R_out',i,fnew(i),gnew(i)

       else
       
        fnew(i) = f(i)
        gnew(i) = g(i)
!        write (6,*) 'Bound-R_in ',i,fnew(i),gnew(i)

      end if

!      write (6,*) 'Bound_v',fnew(-1),gnew(-1),fnew(mx1),gnew(mx1)

      return

   end subroutine set_bound
