! *****************************************************************************
! *   Set parameters                                                          *
! *****************************************************************************

   subroutine set_param
   
      use m_param
      
      implicit none
      real(8):: xLk, wwk
      character(40) cpara

!  ****  Open parameter file  ****

      open ( 10,file='w_para.dat',status='old' )
      
!  ****  Read parameters from a file  ****

      read ( 10,* ) cpara         ! gravity accelaration
      read ( 10,* ) ga
      write( 6,* )  cpara,'=',ga

      read ( 10,* ) cpara         ! Length
      read ( 10,* ) xLk
      write( 6,* )  cpara,'=',xLk

      read ( 10,* ) cpara         ! Mean depth
      read ( 10,* ) H0
      write( 6,* )  cpara,'=',H0

      read ( 10,* ) cpara         ! fluid number
      read ( 10,* ) Fr
      write( 6,* )  cpara,'=',Fr
      
      read ( 10,* ) cpara         ! initial wave amplitude
      read ( 10,* ) wh
      write( 6,* )  cpara,'=',wh

      read ( 10,* ) cpara         ! initial wave width
      read ( 10,* ) wwk
      write( 6,* )  cpara,'=',wwk
      
      read ( 10,* ) cpara         ! time step intervals
      read ( 10,* ) dt
      write( 6,* )  cpara,'=',dt
      
      read ( 10,* ) cpara         ! maximum courant number
      read ( 10,* ) Cmax
      write( 6,* )  cpara,'=',Cmax

      read ( 10,* ) cpara         ! number of grid intervals
      read ( 10,* ) mx
      write( 6,* )  cpara,'=',mx

      read ( 10,* ) cpara         ! number of time steps
      read ( 10,* ) ntmax
      write( 6,* )  cpara,'=',ntmax

      read ( 10,* ) cpara         ! interval time steps for output files
      read ( 10,* ) ifskp
      write( 6,* )  cpara,'=',ifskp

!  ****  convert unit  ****

      xL = xLk * 1.0d3
      ww = wwk * 1.0d3
      
      return

   end subroutine set_param